# -*- coding: utf-8 -*-
"""FZ_World_Bank_source.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1v3wzWEkhtGmKvWFSnONixOyDoTEWeLLm
"""


import pandas as pd
import numpy as np
import psycopg2

def formatted_zone_world_bank():
    df2=pd.read_csv(r'C:\Users\snadal\PycharmProjects\ADSDB\landing\temporal\WDIData.csv')
    df2.head()


    df2=df2.drop(df2.columns[3:49], axis=1)
    df2.drop(df2.columns[1],axis=1,inplace=True)
    df2 = df2.melt(['Country Name','Indicator Name'], var_name='Year', value_name='Value')
    df2.head()

    """Traspose """

    df2 = (df2.pivot_table(index=['Country Name','Year'],
                          columns='Indicator Name',
                          values='Value',
                          margins=True,
                          aggfunc='sum',
                          fill_value=-1))

    df2 = df2.rename_axis(None,axis=1)
    df2=df2.reset_index()
    df2.head()

    df2=df2.drop(columns=['All'], axis=1)
    df2.head()

    df2['Year'] = df2['Year'].astype(str)

    df2.shape[1]

    country=df2['Country Name']
    year=df2['Year']
    df2=df2.drop(columns=['Country Name', 'Year'])
    df2=df2.apply(lambda x: pd.to_numeric(x, errors='coerce'), axis=1)
    df2=df2.applymap(lambda x: round(x,2))
    df2.insert(0, 'Country Name', country)
    df2.insert(1, 'Year', year)

    names={}
    num=0
    for column in df2.columns:
      for i in df2.columns:
        if len(column)>=63 and len(i)>=63:
          if column[0:63]==i[0:63]:
            names[column]=column[0:58]+str(num)
            num+=1

    df2=df2.rename(columns=names)

    df2['Country Name']=df2['Country Name'].apply(lambda x: x.replace("'",""))

    df2['Country Name'].unique()

    """CONNECT TO POSTGRESQL"""

    conn = psycopg2.connect(
        host="localhost",
        database="postgres",
        user="postgres",
        password="ADSDB")
    cursor=conn.cursor()

    tpls = [tuple(x) for x in df2.to_numpy()]
    cols = '" ,"'.join(list(df2.columns))
    cols='"'+cols+'"'
    for i in range(len(tpls)):
      query="INSERT INTO {0}({1}) VALUES ("
      query  = query.format("public.world_data_bank_source20220103", cols)
      tupla=list(tpls[i])

      tupla[0]="'"+tupla[0]+"'"
      tupla[1]="'"+tupla[1]+"'"
      tupla=tuple(tupla)
      for index, v in enumerate(tupla) :
        if index==len(tupla)-1:
          break
        query=query+str(v)+', '
      query=query+str(tupla[len(tupla)-1])+')'
      cursor.execute(query)
      print(tupla[0]+" inserted")
    conn.commit()

    cursor.execute('ROLLBACK;')